package com.vaadin.addon.chameleon.util;

import java.awt.Color;

class Color2 extends Color {

    public Color2(Color color) {
        super(color.getRed(), color.getGreen(), color.getBlue(), color
                .getAlpha());
    }

    @Override
    public Color2 brighter() {
        float[] hsb = Color.RGBtoHSB(getRed(), getGreen(), getBlue(), null);

        // Lower saturation
        hsb[1] = (float) (hsb[1] - hsb[1] * 0.7);
        // Raise brightness
        hsb[2] = (float) (hsb[2] + (1 - hsb[2]) * 0.4);

        return new Color2(Color.getHSBColor(hsb[0], hsb[1], hsb[2]));
    }

    @Override
    public Color2 darker() {
        float[] hsb = Color.RGBtoHSB(getRed(), getGreen(), getBlue(), null);

        // Lower saturation, if not below threshold
        if (hsb[1] > 0.2) {
            hsb[1] = (float) (hsb[1] - hsb[1] * 0.1);
        }
        // Lower brightness
        hsb[2] = (float) (hsb[2] - hsb[2] * 0.2);

        return new Color2(Color.getHSBColor(hsb[0], hsb[1], hsb[2]));
    }

    public Color2 saturate() {
        float[] hsb = Color.RGBtoHSB(getRed(), getGreen(), getBlue(), null);
        hsb[1] = (float) (hsb[1] + (1 - hsb[1]) * 0.2);
        return new Color2(Color.getHSBColor(hsb[0], hsb[1], hsb[2]));
    }

    public String toRGBString() {
        return "rgb(" + getRed() + "," + getGreen() + "," + getBlue() + ")";
    }

    public double luminance() {
        return 0.2126 * getRed() + 0.7152 * getGreen() + 0.0722 * getBlue();
    }
}
